<template>
  <b-modal id="js--add-edit-designation-model" ref="designationModal" size="lg" @hidden="resetModal" hide-footer>
    <div>
      <div class="designation-modal-header mheader shadow">
        <h4 class="title mb-0">
          <span class="color-black">Add/Edit </span>
          <span class="color-theme">Designation</span>
        </h4>
      </div>
      <div v-if="designationForm" class="mt-2">
        <b-row>
          <b-col cols="12" md="12" class="form-card">
             <b-form-group>
                <label class="d-block" for="name">Name <span class="text-danger">*</span></label>
                  <b-form-input id="name" v-model="designationName"  :state="errors.name && errors.name.length > 0 ? false : null"
                    @input="checkValidation('name')" @blur="checkValidation('name')"
                    placeholder="Enter Designation Name" autofocus v-capitalize />
                    <small class="text-danger">{{ errors.name ? errors.name[0] : '' }}</small>
                  </b-form-group>
            </b-col>
          <b-col cols="12" md="12" class="px-1">
            <b-form-group label="Status" label-for="status">
              <b-form-checkbox class="status-switch" :checked="designationStatus" switch name="check-button"
                @change="designationStatus = $event" />
            </b-form-group>
          </b-col>
        </b-row>
        <b-row class="mt-3">
          <b-col cols="12" md="12" class="px-1 text-right">
            <b-button class="btn-reset" variant="flat-secondary" type="button"
              @click="designationForm = !designationForm">
              Cancel
            </b-button>
            <b-button class="btn-submit-edit" variant="primary" type="submit" @click.prevent="validationForm"
              :disabled="isSubmit">
              <b-spinner small v-if="isSubmit" />
              Save
            </b-button>
          </b-col>
        </b-row>
      </div>
      <div v-if="!designationForm" class="mt-2">
        <b-row class="px-1">
          <b-col cols="4" class="search-input-center search-bx d-flex justify-content-start">
          </b-col>
          <b-col cols="4" class="search-input-center search-bx d-flex justify-content-center">
            <div class="d-flex search-input-text index-search-form-group">
              <!--align-items-center justify-content-start-->
              <b-form-group>
                <div class="d-flex align-items-center">
                  <!-- <label class="mr-1">Search</label> -->
                  <IconSearchMute class="custom-search-icon" />
                  <b-form-input v-model="searchQuery" placeholder="Search" type="text"
                    class="d-inline-block custom-search-box" />
                </div>
              </b-form-group>
            </div>
          </b-col>
          <b-col cols="4" class="search-input-center search-bx d-flex justify-content-end">
            <div class="d-flex align-items-center justify-content-end">
              <b-button class="add-button iconviewbutton" variant="primary"
                @click="designationAddEdit('new', '', '', true)" v-if="!designationForm">
                <span class="text-nowrap label-hidden">Add New</span>
                <IconPlusActive />
              </b-button>
            </div>
          </b-col>
        </b-row>
        <div no-body class="mb-0 table-card table-hover table-custom-striped">
          <b-table ref="refListTable" class="position-relative list-table" :items="fetchTableData" responsive
            :fields="tableColumns" primary-key="id" v-model:sort-by="sortBy" show-empty
            empty-text="No matching records found" v-model:sort-desc="isSortDirDesc">
            <!-- Column: Role -->
            <template #cell(sr_no)="data">
              {{ data.index + 1 }}
            </template>
            <template #cell(name)="data">
              <span>{{ data.item.name }}</span>
            </template>
            <template #cell(status)="data">
              <b-badge pill :variant="`light-${resolveUserStatusVariant(data.item.status)}`" class="text-capitalize">
                {{ resolveUserStatusText(data.item.status) }}
              </b-badge>
            </template>
            <template #cell(actions)="data">
              <b-link @click="
    designationAddEdit(
      'edit',
      data.item.id,
      data.item.name,
      data.item.status == 1 ? true : false
    )
    ">
                <IconPencil></IconPencil>
              </b-link>
            </template>
          </b-table>
        </div>
        <div class="mx-1 mb-2 mt-1">
          <b-row class="align-items-center">
            <!-- Per Page -->
            <b-col cols="12" sm="3" class="d-flex align-items-center justify-content-center justify-content-sm-start">
              <!-- <b-button class="tbl-setting-button iconviewbutton" variant="white">
            <b-img :src="icon1Icon" class="" />
            <span class="text-nowrap label-hidden">Table Settings</span>
          </b-button> -->
            </b-col>
            <b-col cols="12" sm="6" class="search-input-center search-bx d-flex justify-content-center">
              <b-row class="align-items-center mb-0 mt-0">
                <div>
                  <span class="text-nowrap mr-1"> Show</span>
                </div>
                <div>
                  <!-- <v-select :searchable="false" class="rounded-lg" v-model="perPage" :options="perPageOptions"
                    :clearable="false" placeholder="Code" :tabindex="5" /> -->
                </div>
                <div>
                  <span class="text-nowrap ml-2">Showing {{ dataMeta.from }} - {{ dataMeta.to }} /
                    {{ dataMeta.of }}</span>
                </div>
              </b-row>
            </b-col>
            <b-col cols="12" sm="3" class="d-flex align-items-center justify-content-center justify-content-sm-end">
              <b-pagination v-model="currentPage" :total-rows="totalData" :per-page="perPage" first-number last-number
                class="mb-0 mt-1 mt-sm-0" prev-class="prev-item" next-class="next-item">
                <template #prev-text>
                  <FeatherIcon icon="ChevronLeftIcon" size="18" />
                </template>
                <template #next-text>
                  <FeatherIcon icon="ChevronRightIcon" size="18" />
                </template>
              </b-pagination>
            </b-col>
          </b-row>
        </div>
      </div>
    </div>
    <!-- <form ref="form" @submit.stop.prevent="handleSubmit">
      <b-form-group
        :state="nameState"
        label="Name"
        label-for="name-input"
        invalid-feedback="Name is required"
      >
        <b-form-input
          id="name-input"
          v-model="name"
          :state="nameState"
          required
        />
      </b-form-group>
    </form> -->
  </b-modal>
</template>

<script>
import {
  BImg,
  BCard,
  BButton,
  BTable,
  BLink,
  BRow,
  BCol,
  BFormInput,
  BFormGroup,
  BForm,
  BModal,
  VBModal,
  BPagination,
  BSpinner,
  BFormSelect,
  BFormCheckbox,
  BBadge,
} from "bootstrap-vue";
import Ripple from "vue-ripple-directive";
import designationModule from "./module";
import designationService from "./service";
import store from "@/store";
import { ref, onUnmounted } from "vue";
// import vSelect from "vue-select";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import commonModule from "../../common/module/index";
import { useToast } from "vue-toastification";
const toast = useToast();
export default {
  components: {
    BCard,
    BImg,
    BButton,
    BTable,
    BLink,
    BRow,
    BCol,
    BFormInput,
    BFormGroup,
    BForm,
    BModal,
    // vSelect,
    BPagination,
    BFormSelect,
    BSpinner,
    BFormCheckbox,
    BBadge,
  },
  setup(props) {
    const MODULE_NAME = "designation";

    // Register module
    if (!store.hasModule(MODULE_NAME))
      store.registerModule(MODULE_NAME, designationService);

    // UnRegister on leave
    onUnmounted(() => {
      // if (store.hasModule(MODULE_NAME)) store.unregisterModule(MODULE_NAME);
    });

    const {
      fetchTableData,
      perPage,
      currentPage,
      totalData,
      dataMeta,
      perPageOptions,
      searchQuery,
      sortBy,
      isSortDirDesc,
      refListTable,
      refetchData,
      resolveUserStatusVariant,
      resolveUserStatusText,
    } = commonModule(MODULE_NAME);

    return {
      // Sidebar
      fetchTableData,
      perPage,
      currentPage,
      totalData,
      dataMeta,
      perPageOptions,
      searchQuery,
      sortBy,
      isSortDirDesc,
      refListTable,
      refetchData,
      resolveUserStatusVariant,
      resolveUserStatusText,
    };
  },

  directives: {
    "b-modal": VBModal,
    Ripple,
  },
  mounted() {
    this.$refs["designationModal"].show();
  },
  data() {
    const tableColumns = [
      { key: "sr_no" },
      { key: "name", sortable: true },
      { key: "status", sortable: true },
      { key: "actions" },
    ];
    return {
      errors: {},
      tableColumns,
      designationForm: false,
      id: "",
      designationName: "",
      designationStatus: true,
      name: "",
      nameState: null,
      submittedNames: [],
      isSubmit: false,
    };
  },
  methods: {
    checkValidation(field = '*') {
     
      if (field == '*' || field == 'name') {
        if (!this.designationName) {
          this.errors['name'] = ['Please enter Designation Name'];
        } else {
          delete this.errors['name'];
        }
      }

      return Object.keys(this.errors).length === 0;
    },
    changeStatus(val, id) {
      return;
    },
    checkFormValidity() {
      const valid = this.$refs.form.checkValidity();
      this.nameState = valid;
      return valid;
    },

    resetModal() {
      this.designationForm = false;
      this.id = "";
      this.designationName = "";
      this.designationStatus = true;
      this.$emit("isModalOpen", false);
    },

    handleOk(bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault();
      // Trigger submit handler
      this.handleSubmit();
    },
    handleSubmit() {
      // Exit when the form isn't valid
      if (!this.checkValidation()) {
        return;
      }
      // Hide the modal manually
      this.$nextTick(() => {
        this.$refs["designationModal"].toggle("#toggle-btn");
      });
    },
    designationAddEdit(type, id = "", name = "", status) {
      if (id && name) {
        this.designationForm = true;
        this.id = id;
        this.designationName = name;
        this.designationStatus = status;
      } else {
        this.designationForm = true;
        this.id = "";
        this.designationName = "";
        this.designationStatus = status;
      }
    },
    validationForm() {
      // this.$refs.addEditFormRules.validate().then((success) => {
        if (this.checkValidation()) {
          var data = {
            name: this.designationName,
            status: this.designationStatus,
          };
          if (this.id) {
            data = {
              id: this.id,
              name: this.designationName,
              status: this.designationStatus,
            };
          }
          this.isSubmit = true;
          store
            .dispatch("designation/save", data)
            .then((response) => {
              if (response.data.status == true) {
                this.isSubmit = false;
                this.designationForm = false;
                this.refetchData();
                this.showToast(
                  "success",
                  "CheckCircleIcon",
                  response.data.title,
                  response.data.message
                );
                this.$emit("submit", true);
                
              } else {
                if (response.data.errors) {
                  this.errors = response.data.errors;
                } else {
                  this.showToast(
                    "danger",
                    "AlertCircleIcon",
                    response.data.title,
                    response.data.message
                  );
                }
                this.isSubmit = false;
              }
            })
            .catch(() => {
              this.isSubmit = false;
            });
        }
      // });
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title: title,
          icon,
          text: message,
          variant,
        },
      });
    },
  },
};
</script>
